(* =========================================================================  
   Map Slide Functions onto Astrobe Library functions

   Target: Hardware-independent
  
   (c) 2009-2015 CFB Software   
   http://www.astrobe.com  
   
   ========================================================================= *)

MODULE Graph;

IMPORT Display := ST7735, Graphics;

CONST
  size = 10;
  whiteOnBlack* = TRUE;
  MaxX* = Display.MaxX;
  MaxY* = Display.MaxY;

VAR
  highX*, highY*: INTEGER;
  colourMap: ARRAY 9 OF INTEGER;

PROCEDURE Init*;
VAR
  i: INTEGER;
BEGIN
  (* AutoCad colours are numbered differently to adapter colours. *)
  (* The colourMap array is used for conversion.                  *)
  colourMap[1] := Display.Red;
  colourMap[2] := Display.Yellow;
  colourMap[3] := Display.Green;
  colourMap[4] := Display.Cyan;
  colourMap[5] := Display.Blue;
  colourMap[6] := Display.Magenta;
  IF whiteOnBlack THEN
  	colourMap[7] := Display.White;
  	colourMap[8] := Display.Black
  ELSE
  	colourMap[7] := Display.Black;
  	colourMap[8] := Display.White
  END;

  highX := Display.MaxX;
  highY := Display.MaxY;
  Display.Init;
  Graphics.Init(Display.MaxX, Display.MaxY, Display.DrawDot)
END Init;

PROCEDURE Line*(fromX, fromY, toX, toY: INTEGER; colour: INTEGER);
BEGIN
  Graphics.Line(colourMap[colour], fromX, fromY, toX, toY)
END Line;

PROCEDURE ClearScreen*();
BEGIN
  Display.ClearScreen(Display.Black)
END ClearScreen;

END Graph.
