MODULE SlideDemo;
(* =========================================================================  
   Main Program for AutoCad Slide Demo
  
   Target: Hardware-independent
   
   (c) 2009-2017  CFB Software   
   http://www.astrobe.com  
   
   ========================================================================= *)

IMPORT Slide, Main, Columbia, StPauls, Timers, Display := ST7735;
 
VAR
  timer: Timers.Timer;
  
PROCEDURE Zoom(slideName: ARRAY OF CHAR);
VAR 
  zoom: REAL;
  i: INTEGER;
BEGIN
  zoom := 0.5;
  FOR i := 1 TO 3 DO 
    Slide.Display(slideName, zoom, 0, 0);
    zoom := zoom + 0.5;
    Timers.Delay(timer, 1000);
  END
END Zoom;

PROCEDURE Pan(slideName: ARRAY OF CHAR);
CONST
  panXInc = (Display.MaxX + 1) DIV 2;
  panYInc = (Display.MaxY + 1) DIV 4;
  zoom = 3.0;
VAR
  panX, panY: INTEGER;
  i: INTEGER;
BEGIN 
  panX := -panXInc;
  panY := 0;
  FOR i := 1 TO 6 DO 
    Slide.Display(slideName, zoom, panX, panY);
    panX := panX + panXInc;
    panY := panY - panYInc;
    Timers.Delay(timer, 1000);
  END
END Pan;

PROCEDURE Run;
BEGIN
  Timers.Init(timer, Timers.TIM3, Timers.MSecs); 
  Slide.Init();
  WHILE TRUE DO
    Zoom("StPauls");
    Pan("StPauls");
    Zoom("Columbia");
    Pan("Columbia")
  END 
END Run;

BEGIN
  Run()
END SlideDemo.
  
